#!/usr/bin/ruby
# encoding: utf-8

# require 'iconv'
require 'gtk2'
require 'vte'
require "rexml/document"
require 'optparse'
require 'sqlite3'

def hide_and_show(showme)
	@layers.each { |k,v|
		v.hide_all
	}
	@layers[showme].show_all
	if showme == "start"
		@back.sensitive = false
		@back.hide_all
	else
		@back.sensitive = true 
		@back.show_all
	end
end

def show_handbook
	helpdir = nil
	[ "toram", "cdrom", "isoloop" ].each { |d|
		helpdir = d if File.exists?("/lesslinux/#{d}/Handbuch-Notfall-DVD.pdf")
	}
	unless helpdir.nil?
		system("evince /lesslinux/#{helpdir}/Handbuch-Notfall-DVD.pdf &")
	end
end

@layers = Hash.new
@evboxes = Hash.new
@images = [ "virenschutz", "datenrettung", "netzwerk", "sicheres-loeschen", "usb-install", "fernwartung", 
	"zugriff-auf-dateisystemebene", "blockebene", "klonen", 
	"netzwerk-einrichten", "netzlaufwerke-verbinden",  "webbrowser-oeffnen",
	"fernzugriff-mit-teamviewer", "vnc-zugriff-zulassen", "remmina-client-oeffnen" ] 
@iconpos = [ [ 180, 105 ], [590, 105], [180, 235], [590,235], [180,365], [590,365], [ 320, 105 ], [320, 235], [320,365], [ 320, 105 ], [320, 235], [320,365], [ 320, 105 ], [320, 235], [320,365] ]
@buttons = Array.new
@cmds = Hash.new

window = Gtk::Window.new
window.border_width = 0
window.window_position = Gtk::Window::POS_CENTER_ALWAYS
window.deletable = false
window.decorated = false
window.allow_grow = false
window.allow_shrink = false
window.set_size_request(960, 530)

fixed = Gtk::Fixed.new
window.add fixed
bgimage = Gtk::Image.new("bgassi.png")
fixed.put(bgimage,0, 0)

# Panels for the pages...
# Startpage first

@layers["start"] = Gtk::Fixed.new
viruslabel = Gtk::Label.new
rescuelabel = Gtk::Label.new
networklabel = Gtk::Label.new
instlabel = Gtk::Label.new
remotelabel = Gtk::Label.new
deletelabel = Gtk::Label.new
[ viruslabel, rescuelabel, networklabel, instlabel, remotelabel, deletelabel ].each { |l|
	l.width_request = 270
	l.wrap = true
	@evboxes[l] = Gtk::EventBox.new
	@evboxes[l].add l 
}
viruslabel.set_markup("<b>Virenscan</b>\nFinden Sie heraus, ob unbemerkte Schadsoftware die Ursache für Abstürze und Instabilitäten ist und reinigen Sie Ihren PC")
rescuelabel.set_markup("<b>Datenrettung und -sicherung</b>\nGreifen Sie auf Laufwerke zu auch wenn Windows nicht startet und retten Sie Daten von beschädigten Festplatten")
networklabel.set_markup("<b>Netzwerk und Internet</b>\nVerbinden Sie sich mit einem WLAN, greifen Sie auf Netzlaufwerke (z.B. eine NAS oder Freigaben anderer Windows-PCs) zu und surfen Sie im Internet")
instlabel.set_markup("<b>USB-Installation</b>\nInstallieren Sie die Notfall-DVD auf USB-Stick (8GB empfohlen), so ist sie immer am Schlüsselbund dabei und der Brenner kann zur Datensicherung genutzt werden")
remotelabel.set_markup("<b>Fernwartung</b>\nGeben Sie Bildschirm, Maus und Tastatur für einen Helfer frei oder greifen Sie auf einen anderen Rechner zu, auf dem die Notfall-CD läuft") 
deletelabel.set_markup("<b>Sicheres Löschen</b>\nLöschen Sie interne Festplatten oder externe Laufwerke, so dass die einst gespeicherten Daten nicht wieder hergestellt werden können, bspw. vor dem Verkauf eines PCs")

@layers["start"].put(@evboxes[viruslabel], 260, 100)
@layers["start"].put(@evboxes[rescuelabel], 670, 100)
@layers["start"].put(@evboxes[networklabel], 260, 230)
@layers["start"].put(@evboxes[deletelabel], 670, 230)
@layers["start"].put(@evboxes[remotelabel], 670, 360)
@layers["start"].put(@evboxes[instlabel], 260, 360)

0.upto(@images.size - 1) { |n|
	@buttons[n] = Gtk::Button.new
	@buttons[n].relief = Gtk::RELIEF_NONE
	@buttons[n].image = Gtk::Image.new(@images[n] + ".jpg")
}
0.upto(5) { |n|
	@layers["start"].put(@buttons[n], @iconpos[n][0], @iconpos[n][1] ) 
}

@evboxes[rescuelabel].signal_connect("button-release-event") { hide_and_show("rescue") } 
@evboxes[networklabel].signal_connect("button-release-event") { hide_and_show("network") } 
@evboxes[remotelabel].signal_connect("button-release-event") { hide_and_show("remote") } 
@buttons[1].signal_connect("clicked") { hide_and_show("rescue") } 
@buttons[2].signal_connect("clicked") { hide_and_show("network") } 
@buttons[5].signal_connect("clicked") { hide_and_show("remote") } 

@cmds["virus"] = "sudo /usr/bin/avg-wrapper.sh &"
@cmds["shred"] = "sudo /usr/bin/deletedisk.sh &"
@cmds["install"] = "sudo /usr/bin/usbinstall.sh &"
@cmds["sorry"] = "zenity --error --text 'Sorry, noch nicht implementiert' &"
@buttons[0].signal_connect("clicked") { system(@cmds["virus"]) } 
@buttons[3].signal_connect("clicked") { system(@cmds["shred"]) } 
@buttons[4].signal_connect("clicked") { system(@cmds["install"]) } 

fixed.put(@layers["start"], 0, 0)

# Search and Rescue
@layers["rescue"] = Gtk::Fixed.new
filemanlabel = Gtk::Label.new
photoreclabel = Gtk::Label.new
imagelabel = Gtk::Label.new
[ filemanlabel, photoreclabel, imagelabel ].each { |l| 
	l.width_request = 540
	l.wrap = true
	@evboxes[l] = Gtk::EventBox.new
	@evboxes[l].add l 
}
filemanlabel.set_markup("<b>Zugriff auf Dateisystemebene</b>\nBinden Sie Laufwerke ein, die zwar beschädigt sind, deren Struktur aber noch intakt ist und kopieren Sie wichtige Daten auf andere Laufwerke. Laufwerke, die Sie zur Datenrettung auswählen, werden nur lesbar eingebunden, um weitere Beschädigungen zu vermeiden.")
photoreclabel.set_markup("<b>Rettung auf Blockebene</b>\nSind die Strukturinformation des Dateisystems beschädigt, kann das Programm PhotoRec häufig Dateien wiederherstellen, indem es Block für Block untersucht. Informationen zu Speicherorten, Dateinamen und Zeitstempel gehen in der Regel verloren.")
imagelabel.set_markup("<b>Klonen eines Laufwerkes</b>\nWeist ein Laufwerk bereits Hardwarefehler auf (\"klackernde\" Festplatte oder gelegentliche Lese- oder Schreibfehler), ist es ratsam eine bitgetreue Kopie auf einem gleich großen oder größeren Laufwerk anzufertigen. Achtung: Das Zielllaufwerk wird hierbei komplett überschrieben!")
@layers["rescue"].put(@evboxes[filemanlabel], 400, 100)
@layers["rescue"].put(@evboxes[photoreclabel], 400, 230)
@layers["rescue"].put(@evboxes[imagelabel], 400, 360)
fixed.put(@layers["rescue"], 0, 0)
6.upto(8) { |n|
	@layers["rescue"].put(@buttons[n], @iconpos[n][0], @iconpos[n][1] ) 
}

@cmds["photorec"] = "/usr/bin/photorec-starter.sh &"
@cmds["clone"] = "sudo /usr/bin/clonedisk.sh &"
@cmds["fileman"] = "sudo /usr/bin/mountall.sh &"
@evboxes[filemanlabel].signal_connect("button-release-event") { system(@cmds["fileman"]) } 
@evboxes[photoreclabel].signal_connect("button-release-event") { system(@cmds["photorec"]) } 
@evboxes[imagelabel].signal_connect("button-release-event") { system(@cmds["clone"]) } 
@buttons[6].signal_connect("clicked") { system(@cmds["fileman"]) } 
@buttons[7].signal_connect("clicked") { system(@cmds["photorec"]) } 
@buttons[8].signal_connect("clicked") { system(@cmds["clone"]) } 
# Network

@layers["network"] = Gtk::Fixed.new
wicdlabel = Gtk::Label.new
shareslabel = Gtk::Label.new
fflabel = Gtk::Label.new
[ wicdlabel, shareslabel, fflabel ].each { |l| 
	l.width_request = 540
	l.wrap = true
	@evboxes[l] = Gtk::EventBox.new
	@evboxes[l].add l 
}
wicdlabel.set_markup("<b>Netzwerk oder WLAN einrichten</b>\nRichten Sie Zugriff auf Ihr drahtloses Netzwerk ein oder vergeben Sie statische IP-Adressen falls Ihr Ethernet dies erfordert. Bei drahtgebundenen Netzen mit aktivem DHCP-Server müssen Sie in der Regel keine Einstellungen vornehmen.")
shareslabel.set_markup("<b>Netzlaufwerke verbinden</b>\nGreifen Sie auf CIFS-Freigaben (Windows-Shares oder NAS-Geräte) zu und ermöglichen Sie es so, Daten über das Netzwerk zu sichern. Unterstützt werden auch WebDAV-Freigaben, wie Sie beispielsweise die Cloudspeicher von Telekom, 1und1 und GMX unterstützen.")
fflabel.set_markup("<b>Webbrowser öffnen</b>\nÖffnen Sie den Webbrowser Firefox, um im Internet nach Lösungen für Ihre PC-Probleme zu suchen oder auf Cloudspeicherdienste zuzugreifen, welche das WebDAV-Protokoll noch nicht unterstützen (Google, Amazon oder DropBox).")
@layers["network"].put(@evboxes[wicdlabel], 400, 100)
@layers["network"].put(@evboxes[shareslabel], 400, 230)
@layers["network"].put(@evboxes[fflabel], 400, 360)
fixed.put(@layers["network"], 0, 0)
9.upto(11) { |n|
	@layers["network"].put(@buttons[n], @iconpos[n][0], @iconpos[n][1] ) 
}

@cmds["wicd"] = "wicd-gtk --no-tray &"
@cmds["www"] = "firefox &"
@cmds["mountnet"] = "sudo mountnet.sh &" 
@evboxes[wicdlabel].signal_connect("button-release-event") { system(@cmds["wicd"]) } 
@evboxes[shareslabel].signal_connect("button-release-event") { system(@cmds["mountnet"]) } 
@evboxes[fflabel].signal_connect("button-release-event") { system(@cmds["www"]) } 
@buttons[9].signal_connect("clicked") { system(@cmds["wicd"]) } 
@buttons[10].signal_connect("clicked") { system(@cmds["mountnet"]) } 
@buttons[11].signal_connect("clicked") { system(@cmds["www"]) } 
# Network
# Fernwartung

@layers["remote"] = Gtk::Fixed.new
tvlabel = Gtk::Label.new
vnclabel = Gtk::Label.new
remminalabel = Gtk::Label.new
[ tvlabel, vnclabel, remminalabel ].each { |l| 
	l.width_request = 540
	l.wrap = true
	@evboxes[l] = Gtk::EventBox.new
	@evboxes[l].add l 
}
tvlabel.set_markup("<b>Fernzugriff mit TeamViewer</b>\nMit TeamViewer können Sie Ihren Desktop einem Helfer freigeben oder auf den freigegebenen Desktop eines anderen Rechners zugreifen. TeamViewer benötigt keine besondere Konfiguration, wenn beide Rechner hinter einer Firewall stehen.")
vnclabel.set_markup("<b>VNC-Zugriff zulassen</b>\nUm bequem von einem anderen Arbeitsplatz im gleichen Netz auf diesen PC zugreifen zu können, aktivieren Sie den VNC-Zugriff. Da VNC keine Verschlüsselung verwendet, wird der Einsatz außerhalb des lokalen Netzwerkes nicht empfohlen.")
remminalabel.set_markup("<b>Remmina-Client öffnen</b>\nMit dem Remmina Remote Desktop Client können Sie auf Rechner zugreifen, die ihren Desktop oder eine Shell über die Protokolle VNC, RDP oder SSH freigeben.")
@layers["remote"].put(@evboxes[tvlabel], 400, 100)
@layers["remote"].put(@evboxes[vnclabel], 400, 230)
@layers["remote"].put(@evboxes[remminalabel], 400, 360)
fixed.put(@layers["remote"], 0, 0)
12.upto(14) { |n|
	@layers["remote"].put(@buttons[n], @iconpos[n][0], @iconpos[n][1] ) 
}

@cmds["team"] = "sudo /usr/bin/teamviewer.sh &"
@cmds["remmina"] = "remmina &"
@cmds["vnc"] = "runx11vnc.sh &"
@evboxes[tvlabel].signal_connect("button-release-event") { system(@cmds["team"]) } 
@evboxes[vnclabel].signal_connect("button-release-event") { system(@cmds["vnc"]) } 
@evboxes[remminalabel].signal_connect("button-release-event") { system(@cmds["remmina"]) } 
@buttons[12].signal_connect("clicked") { system(@cmds["team"]) } 
@buttons[13].signal_connect("clicked") { system(@cmds["vnc"]) } 
@buttons[14].signal_connect("clicked") { system(@cmds["remmina"]) } 

# Buttons that are always visible
@back = Gtk::Button.new(Gtk::Stock::GO_BACK)
@close = Gtk::Button.new(Gtk::Stock::CLOSE)
@help = Gtk::Button.new(Gtk::Stock::HELP)
@mini = Gtk::Button.new # ("minimieren")
@mini.image = Gtk::Image.new("/usr/share/icons/Faenza/actions/16/down.png")
@mini.relief = Gtk::RELIEF_NONE
@mini.has_tooltip = true
@mini.tooltip_text = "Minimieren"
[ @back, @close, @help ].each { |b|
	b.height_request = 40
	b.width_request = 100 
}
fixed.put(@back, 635, 475)
fixed.put(@close, 740, 475)
fixed.put(@help, 845, 475)
fixed.put(@mini, 927, 3)
@back.signal_connect("clicked") { hide_and_show("start") } 
@close.signal_connect("clicked") { Gtk.main_quit } 
@help.signal_connect("clicked") { show_handbook } 
@mini.signal_connect("clicked") {
	window.iconify
	@help.focus = true
}
@help.focus = true

# First show all
window.title = "S.A.D. Rettungsassistent"
window.show_all 
# Then hide all layers
hide_and_show("start")

# Only show the active layer

Gtk.main
